﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RogueLearning
{
    class GameCounters
    {
        public int Tick { get; private set; }
        public int Turn { get; private set; }
        public DateTime StartTime { get; private set; }
        private DateTime LastFrameTime { get; set; }
        private double FrameDelta { get; set; }
        public bool Visible { get; set; }

        public GameCounters()
        {
            Tick = Turn = 0;
            StartTime = DateTime.Now;
            LastFrameTime = StartTime;
            FrameDelta = 0.0;
            Visible = false;
        }

        public double SecondsSinceStart => (DateTime.Now - StartTime).TotalSeconds;
        public double AverageFPS => Tick / SecondsSinceStart;
        public double CurrentFPS => 1.0 / FrameDelta;

        public void NewFrame()
        {
            DateTime now = DateTime.Now;
            Tick++;
            FrameDelta = (now - LastFrameTime).TotalSeconds;
            LastFrameTime = now;
        }

        public void NewTurn()
        {
            Turn++;
        }
    }
}
